<?php
// ----------------------------------------------------------------------
// phpNewsfork - Version 0.1
// http://www.borho.net/news/
// (c) 2001-2002 Martin Borho (martin@borho.net)
//
// LICENSE
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
class meerkat {

      var $tag = "";
      var $id = "";
      var $categories = "";

     /*
     function:          parseCategories
     description:      sets the current tag as class-property
     */
     function startElement($parser, $tagName, $attrs) {
          $this->tag = "$tagName";
     }

     /*
     function:          endElement
     description:      is required from xml_set_element_handler
     */
     function endElement($parser, $tagName) {
     }

     /*
     function:          characterData
     description:      builds an array of categories as class-property
     */
     function characterData($parser, $data) {
          // get current tag
          switch ($this->tag) {
                // if <id>...
                case "ID":
                $this->id = $data;
                break;
                // if <name>...
                case "NAME":
                $this->categories[$this->id] .= $data;
                break;
            }
     }

     /*
     function:          parseCategories
     description:      reads the categories out of cache.xml
     */
     function parseCategories() {

          // Create an XML parser
          $xml_parser = xml_parser_create();
          xml_set_object($xml_parser,&$this);
          // Set the element handlers for opening and closing tags
          xml_set_element_handler($xml_parser, "startElement", "endElement");
          // Set the function to handle character data
          xml_set_character_data_handler($xml_parser, "characterData");
          // Open the XML file for reading
          $fp = fopen("cache.xml","r") or die("Error while reading RSS data.");
          // Read the XML file 4KB at a time
          while ($data = fread($fp, 4096))
          // Parse each 4KB string with the created XML parser
               xml_parse($xml_parser, $data, feof($fp))
          // errorhandling
          or die(sprintf("XML error: %s at line %d",
                 xml_error_string(xml_get_error_code($xml_parser)),
                 xml_get_current_line_number($xml_parser)));
          // Close the file
          fclose($fp);
          // Free up memory used parser
          xml_parser_free($xml_parser);

          // make an array of categories
          foreach ($this->categories as $key => $value) {
                $result[$key]= "$value";
          }

        return $result;
     }

     /*
     function:          checkXMLCache
     description:      if no cache.xml exists or it's too old, $xml_cat signals a new request is required
     */
     function checkXMLCache() {
          // check if cache-file exists, if not create one
          if (!is_file('cache.xml')) {
               if (!@fwrite(fopen("cache.xml","w"), "<?xml version=\"1.0\" encoding=\"UTF-8\"?>")) echo ("Error, no permission to write cache.xml!<br>");
               $xml_cat = "0";
          } else {
               // get the file infos!
               $s = stat("cache.xml");
          }

           // idx 9 is last modification time
           // check if cache-file exists and check if it has a valid time ( < 12 hours )
           if($s && ($s[9] > time()-43200)) {
               $xml_cat = "1";
          } else {
               $xml_cat = "0";
          }

          return $xml_cat;
     }


     /*
     function:          writeCategories
     description:      writes the categories in cache.xml
     */
     function writeCategories($cat_array) {
         foreach ($cat_array as $key => $value) {
               $tags .= "<category><id>$key</id><name>$value</name></category>\n";
          }
          $nav_xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<categories>$tags</categories>";

         @fwrite(fopen("cache.xml","w"), $nav_xml);

     }

     /*
     function:          getNavTree
     description:      makes a html-tree out of $cat_array and opens the node
     */
     function getNavTree($cat_array, $node, $number)  {
              foreach ($cat_array as $id => $name) {
                        if ($node) {
                              // if it's no sub-category surely....
                              if ((!preg_match("[:]", $name)) && (!preg_match("[$node:]", $name))) {
                               $result .= "<small><a href=\"nav.php?node=$name&number=$number\" target=\"navbar\" onclick=\"javascript:void window.open('meerkat.php?catid=$id&num=$number', 'content');\">$name</a></small><br>\n";
                              // if it's a sub-category surely....
                              } elseif (preg_match("[$node:]", $name)) {
                              $result .= "<small><a href=\"meerkat.php?catid=$id&num=$number\" target=\"content\">______$name</a></small><br>\n";
                              }
                         // if it's the first calling....
                         } elseif ((!$node) && (!preg_match("[:]", $name))) {
                               $result .= "<small><a href=\"nav.php?node=$name&number=$number\" target=\"navbar\" onclick=\"javascript:void window.open('meerkat.php?catid=$id&num=$number', 'content');\">$name</a></small><br>\n";
                         }
               }
       return $result;
     }

     /*
     function:          handleHTML
     description:      translates HTML-entities and removes them from the string
     */
     function handleHTML($string) {

        $trans = get_html_translation_table (HTML_ENTITIES);
        $trans = array_flip($trans);
        $string = strtr($string, $trans);
        $result = strip_tags($string);

        return $result;
     }


     /*
     function:          handleDate
     description:      meerkat time-format into european-format
     */
     function handleDate($time) {
        return sprintf("<br/>%02d.%02d.%04d %02d:%02d:%02d h",
                substr($time, 6, 2),
                substr($time, 4, 2),
                substr($time, 0, 4),
                substr($time, 9, 2),
                substr($time, 12, 2),
                substr($time, 15, 2));
     }

     /*
     function:          getMeerkatItems
     description:      makes a request to meerkat with a flavoured recipe
     */
     function getMeerkatItems($param, $time, $num) {

        $client=new xmlrpc_client("/meerkat/xml-rpc/server.php", "www.oreillynet.com", 80);
        $msg = new xmlrpcmsg("meerkat.getItems",
                array(
                        new xmlrpcval(
                                array(
                                        "$param[1]" => new xmlrpcval( "$param[2]" , "$param[3]"),
                                        "time_period" => new xmlrpcval("$time", "string"),
                                        ## display recipe
                                        "ids" => new xmlrpcval(0, "int"),
                                        "descriptions" => new xmlrpcval(1, "int"),
                                        "channels" => new xmlrpcval(1, "int"),
                                        "dates" => new xmlrpcval(1, "int"),
                                        "dc" => new xmlrpcval(0, "int"),
                                        "num_items" => new xmlrpcval("$num", "int"),
                                ),
                        "struct"
                        )
                )
        );

        $response=$client->send($msg);
        $values=$response->value();
        if (!$response->faultCode()) {
                // make a PHP-native array
                $array = xmlrpcDecode($values);
        } else {
                echo "Error-Code :".$response->faultCode()."<br>Error-String: ".$response->faultString()."<br>";
        }

       return $array;
    }
}
?>
