<?xml version = '1.0'?>
<!--phpNewsfork - Version 0.1
http://www.borho.net/news/
(c) 2001-2002 Martin Borho (martin@borho.net)

LICENSE
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License (GPL)
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
To read the license please visit http://www.gnu.org/copyleft/gpl.html

XSLT-Stylesheet for RDF Site Summary 0.9 & 1.0-->
<xsl:stylesheet version="1.0"
        xmlns:rss="http://purl.org/rss/1.0/"
        xmlns:dc="http://purl.org/dc/elements/1.1/"
        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
        xmlns:nets="http://my.netscape.com/rdf/simple/0.9/"
        exclude-result-prefixes="rdf dc rss nets"
>
        <xsl:output method="html"/>

        <!-- main-template for the newschannel, builds the HTML-structure-->
        <xsl:template match="rdf:RDF">
        <html>
                <head>
                        <title>
                                <xsl:value-of select="rss:channel/rss:title | nets:channel/nets:title"/>
                        </title>
                </head>
                <body>
                        <!-- templates for the content-->
                        <xsl:apply-templates select="rss:channel | nets:channel"/>
                        <xsl:apply-templates select="rss:item | nets:item"/>
                        <xsl:apply-templates select="rss:textinput | nets:textinput"/>
                        <xsl:apply-templates select="rss:image | nets:image"/>
                </body>
        </html>
        </xsl:template>

        <!-- template for the channel-node-->
        <xsl:template match="rss:channel | nets:channel">
                <h1>
                        <a>
                                <xsl:attribute name="href">
                                        <xsl:value-of select="rss:link | nets:link"/>
                                </xsl:attribute>
                                <xsl:attribute name="target">_new</xsl:attribute>
                                <xsl:value-of select="rss:title | nets:title"/>
                       </a>
                </h1>
                <xsl:value-of select="rss:description | nets:desciption"/>
                <br/>
                <br/>
        </xsl:template>

        <!-- template for the channel-image-->
        <xsl:template match="rss:image | nets:image">
                <a>
                        <xsl:attribute name="href">
                                <xsl:value-of select="rss:link | nets:link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                   <img>
                        <xsl:attribute name="src">
                                <xsl:value-of select="rss:url | nets:url"/>
                        </xsl:attribute>
                        <xsl:attribute name="alt">
                                <xsl:value-of select="rss:title | nets:title"/>
                         </xsl:attribute>
                         <xsl:attribute name="border">0</xsl:attribute>
                   </img>
                </a>
                <br/><br/>
        </xsl:template>

        <!-- template for item-node, optional output of dublin-core:date.-->
        <xsl:template match="rss:item | nets:item">
                <a>
                        <xsl:attribute name="href">
                                <xsl:value-of select="rss:link | nets:link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                        <xsl:value-of select="rss:title | nets:title"/>
                </a>
                <br/>
                <xsl:value-of select="rss:description"/>
                <br/>
                <xsl:if test="dc:date">
                        <small><i><xsl:value-of select="dc:date"/></i></small>
                </xsl:if>
                <br/>
                <br/>

        </xsl:template>

        <!-- template for the textinput-form-->
        <xsl:template match="rss:textinput | nets:textinpu">
                <b><xsl:value-of select="rss:title | nets:title"/></b>
                <br/>
                <form method="GET" target="_top">
                        <xsl:attribute name="action">
                                <xsl:value-of select="rss:link | nets:link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                        <input type="text" size="20" maxlength="50">
                                <xsl:attribute name="name">
                                        <xsl:value-of select="rss:name | nets:name"/>
                                </xsl:attribute>
                        </input>
                        <input type="submit" name="suchen" value="go"/>
                </form>
                <xsl:value-of select="rss:description | nets:description"/>
                <br/>
                <br/>
        </xsl:template>

</xsl:stylesheet>
