<?xml version = '1.0'?>
<!--phpNewsfork - Version 0.1
http://www.borho.net/news/
(c) 2001-2002 Martin Borho (martin@borho.net)

LICENSE
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License (GPL)
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
To read the license please visit http://www.gnu.org/copyleft/gpl.html

XSLT-Stylesheet for RSS 0.91+ -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >
        <xsl:output method="html"/>

        <!-- main-template for the newschannel, builds the HTML-structure-->
        <xsl:template match="rss">
        <html>
                <head>
                        <title>
                                <xsl:value-of select="channel/title"/>
                        </title>
                </head>
                <body>
                        <xsl:apply-templates select="channel"/>
                </body>
        </html>
        </xsl:template>

        <!-- template for the channel-node, all other templates are invoked from here-->
        <xsl:template match="channel">
                <h1>
                        <a>
                                <xsl:attribute name="href">
                                        <xsl:value-of select="link"/>
                                </xsl:attribute>
                                <xsl:attribute name="target">_new</xsl:attribute>
                                <xsl:value-of select="title"/>
                       </a>
                </h1>
                <xsl:value-of select="description"/>
                <br/>
                <br/>
                <!-- templates for the content-->
                <xsl:apply-templates select="item"/>
                <xsl:apply-templates select="textinput"/>
                <xsl:apply-templates select="image"/>
        </xsl:template>

        <!-- template for channel-image-->
        <xsl:template match="image">
                <a>
                        <xsl:attribute name="href">
                                <xsl:value-of select="link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                   <img>
                        <xsl:attribute name="src">
                                <xsl:value-of select="url"/>
                        </xsl:attribute>
                        <xsl:attribute name="alt">
                                <xsl:value-of select="title"/>
                         </xsl:attribute>
                         <xsl:attribute name="border">0</xsl:attribute>
                   </img>
                </a>
                <br/><br/>
        </xsl:template>

        <!--template for the items-->
        <xsl:template match="item">
                <a>
                        <xsl:attribute name="href">
                                <xsl:value-of select="link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                        <xsl:value-of select="title"/>
                </a>
                <br/>
                <xsl:value-of select="description"/>
                <br/>
                <br/>
        </xsl:template>

        <!-- template for the textinput-form-->
        <xsl:template match="textinput">
                <b><xsl:value-of select="title"/></b>
                <br/>
                <form method="GET" target="_top">
                        <xsl:attribute name="action">
                                <xsl:value-of select="link"/>
                        </xsl:attribute>
                        <xsl:attribute name="target">_new</xsl:attribute>
                        <input type="text" size="20" maxlength="50">
                                <xsl:attribute name="name">
                                        <xsl:value-of select="name"/>
                                </xsl:attribute>
                        </input>
                        <input type="submit" name="suchen" value="go"/>
                </form>
                <xsl:value-of select="description"/>
                <br/>
                <br/>
        </xsl:template>

</xsl:stylesheet>
